=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class Parcel
    # Required if template is not specified
    attr_accessor :distance_unit

    attr_accessor :extra

    # Required if template is not specified
    attr_accessor :height

    # Required if template is not specified
    attr_accessor :length

    attr_accessor :mass_unit

    # A string of up to 100 characters that can be filled with any additional information you want to attach to the object.
    attr_accessor :metadata

    # Date and time of Parcel creation.
    attr_accessor :object_created

    # Unique identifier of the given Parcel object. This ID is required to create a Shipment object.
    attr_accessor :object_id

    # Username of the user who created the Parcel object.
    attr_accessor :object_owner

    # A Parcel will only be valid when all required values have been sent and validated successfully.
    attr_accessor :object_state

    # Date and time of last Parcel update. Since you cannot update Parcels after they were created, this time stamp reflects the time when the Parcel was changed by Shippo's systems for the last time, e.g., during sorting the dimensions given.
    attr_accessor :object_updated

    # Description: If template is passed, length, width, height, and distance_unit are not required
    attr_accessor :template

    # Indicates whether the object has been created in test mode.
    attr_accessor :test

    attr_accessor :weight

    # Required if template is not specified
    attr_accessor :width

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'distance_unit' => :'distance_unit',
        :'extra' => :'extra',
        :'height' => :'height',
        :'length' => :'length',
        :'mass_unit' => :'mass_unit',
        :'metadata' => :'metadata',
        :'object_created' => :'object_created',
        :'object_id' => :'object_id',
        :'object_owner' => :'object_owner',
        :'object_state' => :'object_state',
        :'object_updated' => :'object_updated',
        :'template' => :'template',
        :'test' => :'test',
        :'weight' => :'weight',
        :'width' => :'width'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'distance_unit' => :'Object',
        :'extra' => :'Object',
        :'height' => :'Object',
        :'length' => :'Object',
        :'mass_unit' => :'Object',
        :'metadata' => :'Object',
        :'object_created' => :'Object',
        :'object_id' => :'Object',
        :'object_owner' => :'Object',
        :'object_state' => :'Object',
        :'object_updated' => :'Object',
        :'template' => :'Object',
        :'test' => :'Object',
        :'weight' => :'Object',
        :'width' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::Parcel` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::Parcel`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'distance_unit')
        self.distance_unit = attributes[:'distance_unit']
      end

      if attributes.key?(:'extra')
        self.extra = attributes[:'extra']
      end

      if attributes.key?(:'height')
        self.height = attributes[:'height']
      end

      if attributes.key?(:'length')
        self.length = attributes[:'length']
      end

      if attributes.key?(:'mass_unit')
        self.mass_unit = attributes[:'mass_unit']
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'object_created')
        self.object_created = attributes[:'object_created']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'object_owner')
        self.object_owner = attributes[:'object_owner']
      end

      if attributes.key?(:'object_state')
        self.object_state = attributes[:'object_state']
      end

      if attributes.key?(:'object_updated')
        self.object_updated = attributes[:'object_updated']
      end

      if attributes.key?(:'template')
        self.template = attributes[:'template']
      end

      if attributes.key?(:'test')
        self.test = attributes[:'test']
      end

      if attributes.key?(:'weight')
        self.weight = attributes[:'weight']
      end

      if attributes.key?(:'width')
        self.width = attributes[:'width']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @distance_unit.nil?
        invalid_properties.push('invalid value for "distance_unit", distance_unit cannot be nil.')
      end

      if @height.nil?
        invalid_properties.push('invalid value for "height", height cannot be nil.')
      end

      if @length.nil?
        invalid_properties.push('invalid value for "length", length cannot be nil.')
      end

      if @mass_unit.nil?
        invalid_properties.push('invalid value for "mass_unit", mass_unit cannot be nil.')
      end

      if @weight.nil?
        invalid_properties.push('invalid value for "weight", weight cannot be nil.')
      end

      if @width.nil?
        invalid_properties.push('invalid value for "width", width cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @distance_unit.nil?
      distance_unit_validator = EnumAttributeValidator.new('Object', ['cm', 'in', 'ft', 'm', 'mm', 'yd'])
      return false unless distance_unit_validator.valid?(@distance_unit)
      return false if @height.nil?
      return false if @length.nil?
      return false if @mass_unit.nil?
      mass_unit_validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      return false unless mass_unit_validator.valid?(@mass_unit)
      template_validator = EnumAttributeValidator.new('Object', ['FedEx_Box_10kg', 'FedEx_Box_25kg', 'FedEx_Box_Extra_Large_1', 'FedEx_Box_Extra_Large_2', 'FedEx_Box_Large_1', 'FedEx_Box_Large_2', 'FedEx_Box_Medium_1', 'FedEx_Box_Medium_2', 'FedEx_Box_Small_1', 'FedEx_Box_Small_2', 'FedEx_Envelope', 'FedEx_Padded_Pak', 'FedEx_Pak_1', 'FedEx_Pak_2', 'FedEx_Tube', 'FedEx_XL_Pak', 'UPS_Box_10kg', 'UPS_Box_25kg', 'UPS_Express_Box', 'UPS_Express_Box_Large', 'UPS_Express_Box_Medium', 'UPS_Express_Box_Small', 'UPS_Express_Envelope', 'UPS_Express_Hard_Pak', 'UPS_Express_Legal_Envelope', 'UPS_Express_Pak', 'UPS_Express_Tube', 'UPS_Laboratory_Pak', 'UPS_MI_BPM', 'UPS_MI_BPM_Flat', 'UPS_MI_BPM_Parcel', 'UPS_MI_First_Class', 'UPS_MI_Flat', 'UPS_MI_Irregular', 'UPS_MI_Machinable', 'UPS_MI_MEDIA_MAIL', 'UPS_MI_Parcel_Post', 'UPS_MI_Priority', 'UPS_MI_Standard_Flat', 'UPS_Pad_Pak', 'UPS_Pallet', 'USPS_FlatRateCardboardEnvelope', 'USPS_FlatRateEnvelope', 'USPS_FlatRateGiftCardEnvelope', 'USPS_FlatRateLegalEnvelope', 'USPS_FlatRatePaddedEnvelope', 'USPS_FlatRateWindowEnvelope', 'USPS_IrregularParcel', 'USPS_LargeFlatRateBoardGameBox', 'USPS_LargeFlatRateBox', 'USPS_APOFlatRateBox', 'USPS_LargeVideoFlatRateBox', 'USPS_MediumFlatRateBox1', 'USPS_MediumFlatRateBox2', 'USPS_RegionalRateBoxA1', 'USPS_RegionalRateBoxA2', 'USPS_RegionalRateBoxB1', 'USPS_RegionalRateBoxB2', 'USPS_SmallFlatRateBox', 'USPS_SmallFlatRateEnvelope', 'USPS_SoftPack', 'DHLeC_Irregular', 'DHLeC_SM_Flats', 'couriersplease_500g_satchel', 'couriersplease_1kg_satchel', 'couriersplease_3kg_satchel', 'couriersplease_5kg_satchel', 'Fastway_Australia_Satchel_A2', 'Fastway_Australia_Satchel_A3', 'Fastway_Australia_Satchel_A4', 'Fastway_Australia_Satchel_A5'])
      return false unless template_validator.valid?(@template)
      return false if @weight.nil?
      return false if @width.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] distance_unit Object to be assigned
    def distance_unit=(distance_unit)
      validator = EnumAttributeValidator.new('Object', ['cm', 'in', 'ft', 'm', 'mm', 'yd'])
      unless validator.valid?(distance_unit)
        fail ArgumentError, "invalid value for \"distance_unit\", must be one of #{validator.allowable_values}."
      end
      @distance_unit = distance_unit
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] mass_unit Object to be assigned
    def mass_unit=(mass_unit)
      validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      unless validator.valid?(mass_unit)
        fail ArgumentError, "invalid value for \"mass_unit\", must be one of #{validator.allowable_values}."
      end
      @mass_unit = mass_unit
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] template Object to be assigned
    def template=(template)
      validator = EnumAttributeValidator.new('Object', ['FedEx_Box_10kg', 'FedEx_Box_25kg', 'FedEx_Box_Extra_Large_1', 'FedEx_Box_Extra_Large_2', 'FedEx_Box_Large_1', 'FedEx_Box_Large_2', 'FedEx_Box_Medium_1', 'FedEx_Box_Medium_2', 'FedEx_Box_Small_1', 'FedEx_Box_Small_2', 'FedEx_Envelope', 'FedEx_Padded_Pak', 'FedEx_Pak_1', 'FedEx_Pak_2', 'FedEx_Tube', 'FedEx_XL_Pak', 'UPS_Box_10kg', 'UPS_Box_25kg', 'UPS_Express_Box', 'UPS_Express_Box_Large', 'UPS_Express_Box_Medium', 'UPS_Express_Box_Small', 'UPS_Express_Envelope', 'UPS_Express_Hard_Pak', 'UPS_Express_Legal_Envelope', 'UPS_Express_Pak', 'UPS_Express_Tube', 'UPS_Laboratory_Pak', 'UPS_MI_BPM', 'UPS_MI_BPM_Flat', 'UPS_MI_BPM_Parcel', 'UPS_MI_First_Class', 'UPS_MI_Flat', 'UPS_MI_Irregular', 'UPS_MI_Machinable', 'UPS_MI_MEDIA_MAIL', 'UPS_MI_Parcel_Post', 'UPS_MI_Priority', 'UPS_MI_Standard_Flat', 'UPS_Pad_Pak', 'UPS_Pallet', 'USPS_FlatRateCardboardEnvelope', 'USPS_FlatRateEnvelope', 'USPS_FlatRateGiftCardEnvelope', 'USPS_FlatRateLegalEnvelope', 'USPS_FlatRatePaddedEnvelope', 'USPS_FlatRateWindowEnvelope', 'USPS_IrregularParcel', 'USPS_LargeFlatRateBoardGameBox', 'USPS_LargeFlatRateBox', 'USPS_APOFlatRateBox', 'USPS_LargeVideoFlatRateBox', 'USPS_MediumFlatRateBox1', 'USPS_MediumFlatRateBox2', 'USPS_RegionalRateBoxA1', 'USPS_RegionalRateBoxA2', 'USPS_RegionalRateBoxB1', 'USPS_RegionalRateBoxB2', 'USPS_SmallFlatRateBox', 'USPS_SmallFlatRateEnvelope', 'USPS_SoftPack', 'DHLeC_Irregular', 'DHLeC_SM_Flats', 'couriersplease_500g_satchel', 'couriersplease_1kg_satchel', 'couriersplease_3kg_satchel', 'couriersplease_5kg_satchel', 'Fastway_Australia_Satchel_A2', 'Fastway_Australia_Satchel_A3', 'Fastway_Australia_Satchel_A4', 'Fastway_Australia_Satchel_A5'])
      unless validator.valid?(template)
        fail ArgumentError, "invalid value for \"template\", must be one of #{validator.allowable_values}."
      end
      @template = template
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          distance_unit == o.distance_unit &&
          extra == o.extra &&
          height == o.height &&
          length == o.length &&
          mass_unit == o.mass_unit &&
          metadata == o.metadata &&
          object_created == o.object_created &&
          object_id == o.object_id &&
          object_owner == o.object_owner &&
          object_state == o.object_state &&
          object_updated == o.object_updated &&
          template == o.template &&
          test == o.test &&
          weight == o.weight &&
          width == o.width
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [distance_unit, extra, height, length, mass_unit, metadata, object_created, object_id, object_owner, object_state, object_updated, template, test, weight, width].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
